unit Ziffernsystem;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TZiffernsysteme = class(TForm)
    StartBasis: TSpinEdit;
    StartLabelBasis: TLabel;
    Eingabe: TEdit;
    LabelZahl: TLabel;
    Rechne: TButton;
    Ausgabe: TEdit;
    LabelErgebnis: TLabel;
    ZielBasis: TSpinEdit;
    LabelZielBasis: TLabel;
    procedure RechneClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Ziffernsysteme: TZiffernsysteme;

implementation

{$R *.DFM}

 procedure TZiffernsysteme.RechneClick(Sender: TObject);
  const Ziffer = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
  var Rest,LZ,K,DezZahl,BasisS,BasisZ,Wo:Longint;
      Zeichen:Char;
      Ergebnis,ZSystem:String;
  begin
   BasisS:=StartBasis.Value;
   BasisZ:=ZielBasis.Value;
   ZSystem:=Copy(Ziffer,1,BasisS);
   LZ:=Length(Eingabe.Text);DezZahl:=0;
   For K:=1 to LZ do
    Begin
     Zeichen:=Eingabe.Text[K];
     Wo:=Pos(Zeichen,ZSystem);
     If Wo>0 then DezZahl:=DezZahl*BasisS+Wo-1
     Else
      Begin Ausgabe.Text:='Eingabefehler an der '+IntToStr(K)+'-ten Stelle!';Exit End
    End;
   Ergebnis:='';
   repeat
    Rest:=DezZahl mod BasisZ;
    DezZahl:=DezZahl div BasisZ;
    Ergebnis:=Ziffer[Rest+1]+Ergebnis
   until DezZahl=0;
   Ausgabe.Text:=Ergebnis
  end;

end.
